RFC6374 Synonymous Flow Labels
Stewart Bryant
Futurewei Technologies Inc.
sb@stewartbryant.com
George Swallow
Southend Technical Center
swallow.ietf@gmail.com
Mach Chen
Huawei
mach.chen@huawei.com
Giuseppe Fioccola
Huawei Technologies
giuseppe.fioccola@huawei.com
Gregory Mirsky
ZTE Corp.
gregimirsky@gmail.com
05 March 2021
MPLS Working Group
RFC 6374 describes methods of making loss and delay measurements on Label Switched Paths (LSPs) primarily as used in MPLS Transport Profile (MPLS-TP) networks. This document describes a method of extending RFC 6374 performance measurements from flows carried over MPLS-TP to flows carried over generic MPLS LSPs. In particular, it extends the technique to allow loss and delay measurements to be made on multi-point to point LSPs and introduces some additional techniques to allow more sophisticated measurements to be made in both MPLS-TP and generic MPLS networks.

Introduction
[RFC6374] was originally designed for use as an Operations, Administration, and Maintenance (OAM) protocol for use with MPLS Transport Profile (MPLS-TP) [RFC5921] LSPs. MPLS-TP only supports point-to-point and point-to-multi-point LSPs. This document describes how to use RFC6374 in the generic MPLS case, and also introduces a number of more sophisticated measurements of applicability to both cases.
[RFC8372] describes the requirement for introducing flow identities when using RFC6374 [RFC6374] packet Loss Measurements (LM). In summary RFC6374 uses the loss-measurement (LM) packet as the packet accounting demarcation point. Unfortunately this gives rise to a number of problems that may lead to significant packet accounting errors in certain situations. For example:
1. Where a flow is subjected to Equal Cost Multi-Path (ECMP) treatment packets can arrive out of order with respect to the LM packet.
2. Where a flow is subjected to ECMP treatment, packets can arrive at different hardware interfaces, thus requiring reception of an LM packet on one interface to trigger a packet accounting action on a different interface which may not be co-located with it. This is a difficult technical problem to address with the required degree of accuracy.
3. Even where there is no ECMP (for example on RSVP-TE, MPLS-TP LSPs and pseudowires(PWs)) local processing may be distributed over a number of processor cores, leading to synchronization problems.
4. Link aggregation techniques [RFC7190] may also lead to synchronization issues.
5. Some forwarder implementations have a long pipeline between processing a packet and incrementing the associated counter, again leading to synchronization difficulties.
An approach to mitigating these synchronization issue is described in [RFC8321] in which packets are batched by the sender and each batch is marked in some way such that adjacent batches can be easily recognized by the receiver.
An additional problem arises where the LSP is a multi-point to point LSP, since MPLS does not include a source address in the packet. Network management operations require the measurement of packet loss between a source and destination. It is thus necessary to introduce some source specific information into the packet to identify packet batches from a specific source.
[RFC8957] describes a method of encoding per flow instructions in an MPLS label stack using a technique called Synonymous Flow Labels (SFL) in which labels which mimic the behavior of other labels provide the packet batch identifiers and enable the per batch packet accounting. This memo specifies how SFLs are used to perform RFC6374 packet loss and RFC6374 delay measurements.

Requirements Language
The key words “MUST”, “MUST NOT”, “REQUIRED”, “SHALL”, “SHALL NOT”, “SHOULD”, “SHOULD NOT”, “RECOMMENDED”, “NOT RECOMMENDED”, “MAY”, and “OPTIONAL” in this document are to be interpreted as described in BCP 14 [RFC2119] [RFC8174] when, and only when, they appear in all capitals, as shown here.

RFC6374 Packet Loss Measurement with SFL
The data service packets of the flow being instrumented are grouped into batches, and all the packets within a batch are marked with the SFL [RFC8372] corresponding to that batch. The sender counts the number of packets in the batch. When the batch has completed and the sender is confident that all of the packets in that batch will have been received, the sender issues an RFC6374 Query message to determine the number actually received and hence the number of packets lost. The RFC6374 Query message is sent using the same SFL as the corresponding batch of data service packets. The format of the Query and Response packets is described in Section 9.

RFC6374 Single Packet Delay Measurement
RFC6374 describes how to measure the packet delay by measuring the transit time of an RFC6374 packet over an LSP. Such a packet may not need to be carried over an SFL since the delay over a particular LSP should be a function of the Traffic Class (TC) bits.
However, where SFLs are being used to monitor packet loss or where label inferred scheduling is used [RFC3270] then the SFL would be REQUIRED to ensure that the RFC6374 packet which was being used as a proxy for a data service packet experienced a representative delay. The format of an RFC6374 packet carried over the LSP using an SFL is shown in Section 9.

Data Service Packet Delay Measurement
Where it is desired to more thoroughly instrument a packet flow and to determine the delay of a number of packets it is undesirable to send a large number of RFC6374 packets acting as a proxy data service packets (see Section 4). A method of directly measuring the delay characteristics of a batch of packets is therefore needed.
Given the long intervals over which it is necessary to measure packet loss, it is not necessarily the case that the batch times for the two measurement types would be identical. Thus, we use a technique that permits the two measurements are made concurrently and yet relatively independent from each other. The notion that they are relatively independent arises from the potential for the two batches to overlap in time, in which case either the delay batch time will need to be cut short or the loss time will need to be extended to allow correct reconciliation of the various counters.
The problem is illustrated in Figure 1 below:

RFC6734 Query Packet with SFL

   (1) AAAAAAAAAABBBBBBBBBBAAAAAAAAAABBBBBBBBBB

   SFL Marking of a packet batch for loss measurement

   (2) AADDDDAAAABBBBBBBBBBAAAAAAAAAABBBBBBBBBB

   SFL Marking of a subset of the packets for delay

   (3) AAAAAAAADDDDBBBBBBBBAAAAAAAAAABBBBBBBBBB

   SFL Marking of a subset of the packets across a
   packet loss measurement boundary

   (4) AACDCDCDAABBBBBBBBBBAAAAAAAAAABBBBBBBBBB

   The case of multiple delay measurements within
   a packet loss measurement

   A & B are packets where loss is being measured
   C & D are pacekts where loss and delay is being measured

In case 1 of Figure 1 we show the case where loss measurement alone is being carried out on the flow under analysis. For illustrative purposes consider that 10 packets are used in each flow in the time interval being analyzed.
Now consider case 2 of Figure 1 where a small batch of packets need to be analyzed for delay. These are marked with a different SFL type indicating that they are to be monitored for both loss and delay. The SFL=A indicates loss batch A, SFL=D indicates a batch of packets that are to be instrumented for delay, but SFL D is synonymous with SFL A, which in turn is synonymous with the underlying Forwarding Equivalence Class (FEC). Thus, a packet marked D will be accumulated into the A loss batch, into the delay statistics and will be forwarded as normal. Whether the packet is actually counted twice (for loss and delay) or whether the two counters are reconciled during reporting is a local matter.
Now consider case 3 of Figure 1 where a small batch of packets are marked for delay across a loss batch boundary. These packets need to be considered as part of batch A or a part of batch B, and any RFC6374 Query needs to take place after all the packets A or D (whichever option is chosen) have arrived at the receiving LSR.
Now consider case 4 of Figure 1. Here we have a case where it is required to take a number of delay measurements within a batch of packets that we are measuring for loss. To do this we need two SFLs for delay (C and D) and alternate between them (on a delay batch by delay batch basis) for the purposes of measuring the delay characteristics of the different batches of packets.

Some Simplifying Rules
It is possible to construct a large set of overlapping measurement types, in terms of loss, delay, loss and delay and batch overlap. If we allow all combinations of cases, this leads to configuration, testing and implementation complexity and hence increased costs. The following simplifying rules represent the default case:
1. Any system that needs to measure delay MUST be able to measure loss.
2. Any system that is to measure delay MUST be configured to measure loss. Whether the loss statistics are collected or not is a local matter.
3. A delay measurement MAY start at any point during a loss measurement batch, subject to rule 4.
4. A delay measurement interval MUST be short enough that it will complete before the enclosing loss batch completes.
5. The duration of a second delay (D in Figure 1 batch must be such that all packets from the packets belonging to a first delay batch (C in Figure 1)will have been received before the second delay batch completes. This condition is satisfied when the time to send a batch is long compared to the network propagation time, and is a parameter that can be established by the network operator.
Given that the sender controls both the start and duration of a loss and a delay packet batch, these rules are readily implemented in the control plane.

Multiple Packet Delay Characteristics
A number of methods are described which add to the set of measurements originally specified in [RFC6374]. Each of these methods has different characteristics and different processing demands on the packet forwarder. The choice of method will depend on the type of diagnostic that the operator seeks.
Three Methods are discussed:
1. Time Buckets
2. Classic Standard Deviation
3. Average Delay

Method 1: Time Buckets
In this method the receiving LSR measures the inter-packet gap, classifies the delay into a number of delay buckets and records the number of packets in each bucket. As an example, if the operator were concerned about packets with a delay of up to 1us, 2us, 4us, 8us, and over 8us then there would be five buckets and packets that arrived up to 1us would cause the 1us bucket counter to increase, between 1us and 2us the 2us bucket counter would increase etc. In practice it might be better in terms of processing and potential parallelism if, when a packet had a delay relative to its predecessor of 2us, then both the up to 1us and the 2us counter were incremented, and any more detailed information was calculated in the analytics system.
This method allows the operator to see more structure in the jitter characteristics than simply measuring the average jitter, and avoids the complication of needing to perform a per packet multiply, but will probably need the time intervals between buckets to be programmable by the operator.
The packet format of a Time Bucket Jitter Measurement Message is shown below:

Time Bucket Jitter Measurement Message Format

 0                   1                   2                   3
 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
|Version| Flags |  Control Code |        Message Length         |
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
|  QTF  |  RTF  | RPTF  |              Reserved                 |
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
|                       Session Identifier          |    DS     |
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
| Number of     |      Reserved 1                               |
| Buckets       |                                               |
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
|                   Interval in 10ns units                      |
|                                                               |
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
|                   Number pkts in Bucket                       |
|                                                               |
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
~                                                               ~
~                                                               ~
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
~                                                               ~
~                           TLV Block                           ~
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

The Version, Flags, Control Code, Message Length, QTF, RTF, RPTF, Session Identifier, Reserved and DS Fields are as defined in section 3.2 of RFC6374. The remaining fields, which are unsigned integers, are as follows:

o Number of Buckets in the measurement

o Reserved 1 must be sent as zero and ignored on receipt

o Interval in 10ns units is the inter-packet interval for
  this bucket

o Number Pkts in Bucket is the number of packets found in
  this bucket.

There will be a number of Interval/Number pairs depending on the number of buckets being specified by the Querier. If an RFC6374 message is being used to configure the buckets, (i.e. the responder is creating or modifying the buckets according to the intervals in the Query message), then the Responder MUST respond with 0 packets in each bucket until it has been configured for a full measurement period. This indicates that it was configured at the time of the last response message, and thus the response is valid for the whole interval. As per the [RFC6374] convention the Number of pkts in Bucket fields are included in the Query message and set to zero.
Out of band configuration is permitted by this mode of operation.
Note this is a departure from the normal fixed format used in RFC6374.
The time bucket jitter measurement message is carried over an LSP in the way described in [RFC6374] and over an LSP with an SFL as described in Section 9.

Method 2 Classic Standard Deviation
In this method, provision is made for reporting the following delay characteristics:
1. Number of packets in the batch (n).
2. Sum of delays in a batch (S)
3. Maximum Delay.
4. Minimum Delay.
5. Sum of squares of Inter-packet delay (SS).
Characteristics 1 and 2 give the mean delay. Measuring the delay of each pair in the batch is discussed in Section 7.3.
Characteristics 3 and 4 give the outliers.
Characteristics 1, 2 and 5 can be used to calculate the variance of the inter-packet gap and hence the standard deviation giving a view of the distribution of packet delays and hence the jitter. The equation for the variance (var) is given by:

var = (SS - S*S/n)/(n-1)

There is some concern over the use of this algorithm for measuring variance, because SS and S*S/n can be similar numbers, particularly where variance is low. However the method commends it self by not requiring a division in the hardware.

Multi-Packet Delay Measurement Message Format
The packet format of a Multi-Packet Delay Measurement Message is shown below:

Multi-packet Delay Measurement Message Format

 0                   1                   2                   3
 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
|Version| Flags |  Control Code |        Message Length         |
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
|  QTF  |  RTF  | RPTF  |              Reserved                 |
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
|                       Session Identifier          |    DS     |
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
|                      Number of Packets                        |
|                                                               |
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
|                   Sum of Delays for Batch                     |
|                                                               |
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
|                       Minimum Delay                           |
|                                                               |
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
|                       Maximum Delay                           |
|                                                               |
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
|                Sum of squares of Inter-packet delay           |
|                                                               |
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
~                                                               ~
~                           TLV Block                           ~
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

The Version, Flags, Control Code, Message Length, QTF, RTF, RPTF, Session Identifier, Reserved and DS Fields are as defined in section 3.2 of RFC6374. The remaining fields are as follows:

o Number of Packets is the number of packets in this batch

o Sum of Delays for Batch is the duration of the batch in the
  time measurement format specified in the RTF field.

o Minimum Delay is the minimum inter-packet gap observed during
  the batch in the time format specified in the RTF field.

o Maximum Delay is the maximum inter-packet gap observed during
  the batch in the time format specified in the RTF field.

The multi-packet delay measurement message is carried over an LSP in the way described in [RFC6374] and over an LSP with an SFL as described in Section 9.

Per Packet Delay Measurement
If detailed packet delay measurement is required then it might be possible to record the inter-packet gap for each packet pair. In other than exception cases of slow flows or small batch sizes, this would create a large (per packet) demand on storage in the instrumentation system, a large bandwidth to such a storage system and large bandwidth to the analytics system. Such a measurement technique is outside the scope of this document.

Average Delay
Introduced in [RFC8321] is the concept of a one way delay measurement in which the average time of arrival of a set of packets is measured. In this approach the packet is time-stamped at arrival and the Responder returns the sum of the time-stamps and the number of times-tamps. From this the analytics engine can determine the mean delay. An alternative model is that the Responder returns the time stamp of the first and last packet and the number of packets. This later method has the advantage of allowing the average delay to be determined at a number of points along the packet path and allowing the components of the delay to be characterized. Unless specifically configured otherwise, the responder may return either or both types of response and the analytics engine should process the response appropriately.
The packet format of an Average Delay Measurement Message is shown below:

Average Delay Measurement Message Format

 0                   1                   2                   3
 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
|Version| Flags |  Control Code |        Message Length         |
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
|  QTF  |  RTF  | RPTF  |              Reserved                 |
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
|                       Session Identifier          |    DS     |
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
|                      Number of Packets                        |
|                                                               |
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
|                      Time of First Packet                     |
|                                                               |
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
|                      Time of Last Packet                      |
|                                                               |
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
|                   Sum of Timestamps of Batch                  |
|                                                               |
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

~                                                               ~
~                           TLV Block                           ~
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

The Version, Flags, Control Code, Message Length, QTF, RTF, RPTF, Session Identifier, and DS Fields are as defined in section 3.2 of RFC6374. The remaining fields are as follows:

o Number of Packets is the number of packets in this batch.

o Time of First Packet is the time of arrival of the first
  packet in the batch.

o Time of Last Packet is the time of arrival of the last
  packet in the batch.

o Sum of Timestamps of Batch.

The average delay measurement message is carried over an LSP in the way described in [RFC6374] and over an LSP with an SFL as described in Section 9. As is the convention with RFC6374, the Query message contains placeholders for the Response message. The placeholders are sent as zero.

Sampled Measurement
In the discussion so far it has been assumed that we would measure the delay characteristics of every packet in a delay measurement interval defined by an SFL of constant color. In [RFC8321] the concept of a sampled measurement is considered. That is the Responder only measures a packet at the start of a group of packets being marked for delay measurement by a particular color, rather than every packet in the marked batch. A measurement interval is not defined by the duration of a marked batch of packets but the interval between a pair of RFC6374 packets taking a readout of the delay characteristic. This approach has the advantage that the measurement is not impacted by ECMP effects.
This sampled approach may be used if supported by the Responder and configured by the opertor.

Carrying RFC6374 Packets over an LSP using an SFL
We illustrate the packet format of an RFC6374 Query message using SFLs for the case of an MPLS direct loss measurement in Figure 5.

RFC6734 Query Packet with SFL

+-------------------------------+
|                               |
|             LSP               |
|            Label              |
+-------------------------------+
|                               |
|        Synonymous Flow        |
|            Label              |
+-------------------------------+
|                               |
|            GAL                |
|                               |
+-------------------------------+
|                               |
|      ACH Type = 0xA           |
|                               |
+-------------------------------+
|                               |
|  RFC6374 Measurement Message  |
|                               |
|  +-------------------------+  |
|  |                         |  |
|  |      Fixed-format       |  |
|  |      portion of msg     |  |
|  |                         |  |
|  +-------------------------+  |
|  |                         |  |
|  |      Optional SFL TLV   |  |
|  |                         |  |
|  +-------------------------+  |
|  |                         |  |
|  |      Optional Return    |  |
|  |      Information        |  |
|  |                         |  |
|  +-------------------------+  |
|                               |
+-------------------------------+

The MPLS label stack is exactly the same as that used for the user data service packets being instrumented except for the inclusion of the Generic Associated Channel Label (GAL) [RFC5586] to allow the receiver to distinguish between normal data packets and OAM packets. Since the packet loss measurements are being made on the data service packets, an RFC6374 direct loss measurement is being made, and which is indicated by the type field in the ACH (Type = 0x000A).
The RFC6374 measurement message consists of the three components, the RFC6374 fixed-format portion of the message as specified in [RFC6374] carried over the ACH channel type specified the type of measurement being made (currently: loss, delay or loss and delay) as specified in RFC6374.
Two optional TLVs MAY also be carried if needed. The first is the SFL TLV specified in Section 9.1. This is used to provide the implementation with a reminder of the SFL that was used to carry the RFC6374 message. This is needed because a number of MPLS implementations do not provide the MPLS label stack to the MPLS OAM handler. This TLV is required if RFC6374 messages are sent over UDP [RFC7876]. This TLV MUST be included unless, by some method outside the scope of this document, it is known that this information is not needed by the RFC6374 Responder.
The second set of information that may be needed is the return information that allows the responder send the RFC6374 response to the Querier. This is not needed if the response is requested in-band and the MPLS construct being measured is a point to point LSP, but otherwise MUST be carried. The return address TLV is defined in [RFC6374] and the optional UDP Return Object is defined in [RFC7876].
Where a measurement other than an MPLS direct loss measurement is to be made, the appropriate RFC6374 measurement message is used (for example, one of the new types defined in this document) and this is indicated to the receiver by the use of the corresponding ACH type.

RFC6374 SFL TLV
The RFC6374 SFL TLV is shown in Figure 6. This contains the SFL that was carried in the label stack, the FEC that was used to allocate the SFL and the index into the batch of SLs that were allocated for the FEC that corresponds to this SFL.

SFL TLV

 0                   1                   2                   3
 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
|    Type       |    Length     |MBZ| SFL Batch |    SFL Index  |
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
|                 SFL                   |        Reserved       |
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
|                 FEC                                           |
.                                                               .
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

Where:

Type      Type is set to Synonymous Flow Label (SFL-TLV).

Length    The length of the TLV as specified in RFC6374.

MBZ       MUST be sent as zero and ignored on receive.

SFL Batch The SFL batch that this SFL was allocated as part
          of see [I-D.bryant-mpls-sfl-control]

SPL Index The index into the list of SFLs that were assigned
          against the FEC that corresponds to the SFL.

          Multiple SFLs can be assigned to a FEC each
          with different actions. This index is an optional
          convenience for use in mapping between the TLV
          and the associated data structures in the LSRs.
          The use of this feature is agreed between the
          two parties during configuration. It is not required,
          but is a convenience for the receiver if both parties
          support the facility,

SFL       The SFL used to deliver this packet.  This is an MPLS
          label which is a component of a label stack entry as
          defined in Section 2.1 of [RFC3032].

Reserved  MUST be sent as zero and ignored on receive.

FEC       The Forwarding Equivalence Class that was used to
          request this SFL.  This is encoded as per
          Section 3.4.1 of [RFC5036]

This information is needed to allow for operation with hardware that discards the MPLS label stack before passing the remainder of the stack to the OAM handler. By providing both the SFL and the FEC plus index into the array of allocated SFLs a number of implementation types are supported.

RFC6374 Combined Loss-Delay Measurement
This mode of operation is not currently supported by this specification.

Privacy Considerations
The inclusion of originating and/or flow information in a packet provides more identity information and hence potentially degrades the privacy of the communication. Whilst the inclusion of the additional granularity does allow greater insight into the flow characteristics it does not specifically identify which node originated the packet other than by inspection of the network at the point of ingress, or inspection of the control protocol packets. This privacy threat may be mitigated by encrypting the control protocol packets, regularly changing the synonymous labels and by concurrently using a number of such labels.

Security Considerations
The security considerations documented in [RFC6374] and [RFC8372] (which in turn calls up [RFC7258] and [RFC5920]) are applicable to this protocol.
The issue noted in Section 11 is a security consideration. There are no other new security issues associated with the MPLS dataplane. Any control protocol used to request SFLs will need to ensure the legitimacy of the request.
An attacker that manages to corrupt the RFC6374 SFL TLV Section 9.1 could disrupt the measurements in a way that the RFC6374 responder is unable to detect. However, the network opertator is likely to notice the anomalous network performance measurements, and in any case normal MPLS network security proceedures make this type of attack extremely unlikley.

IANA Considerations

Allocation of MPLS Generalized Associated Channel (G-ACh) Types
As per the IANA considerations in [RFC5586] updated by [RFC7026] and [RFC7214], IANA is requested to allocate the following codeponts in the “MPLS Generalized Associated Channel (G-ACh) Type” registry, in the “Generic Associated Channel (G-ACh) Parameters” name space:

Value  Description                            Reference
-----  ---------------------------------      -----------
TBD    RFC6374 Time Bucket Jitter Measurement This

TBD    RFC6374 Multi-Packet Delay             This
       Measurement

TBD    RFC6374 Average Delay Measurement      This

Allocation of MPLS Loss/Delay TLV Object
IANA is requested to allocate a new TLV from the 0-127 range of the MPLS Loss/Delay Measurement TLV Object Registry in the “Generic Associated Channel (G-ACh) Parameters” namespace:

  Type Description                       Reference
  ---- --------------------------------- ---------
  TBD  Synonymous Flow Label             This

A value of 4 is recommended.
RFC Editor please delete this para [RFC3032][I-D.bryant-mpls-sfl-control][RFC5036]

Acknowledgments
The authors thank Benjamin Kaduk and Elwyn Davies for their thorough and thoughtful review of this document.

Contributing Authors

 Zhenbin Li
 Huawei
 Email: lizhenbin@huawei.com

 Siva Sivabalan
 Ciena Corporation
 Email: ssivabal@ciena.com

Normative References
[I-D.bryant-mpls-sfl-control]

A Simple Control Protocol for MPLS SFLs
Stewart Bryant
George Swallow
Siva Sivabalan
7 December 2020
Internet-Draft draft-bryant-mpls-sfl-control-09
[RFC2119]

Key words for use in RFCs to Indicate Requirement Levels
S. Bradner
March 1997
BCP 14
RFC 2119
DOI 10.17487/RFC2119
[RFC8174]

Ambiguity of Uppercase vs Lowercase in RFC 2119 Key Words
B. Leiba
May 2017
BCP 14
RFC 8174
DOI 10.17487/RFC8174
[RFC3032]

MPLS Label Stack Encoding
E. Rosen
D. Tappan
G. Fedorkow
Y. Rekhter
D. Farinacci
T. Li
A. Conta
January 2001
RFC 3032
DOI 10.17487/RFC3032
[RFC7876]

UDP Return Path for Packet Loss and Delay Measurement for MPLS Networks
S. Bryant
S. Sivabalan
S. Soni
July 2016
RFC 7876
DOI 10.17487/RFC7876
[RFC5586]

MPLS Generic Associated Channel
M. Bocci, Ed.
M. Vigoureux, Ed.
S. Bryant, Ed.
June 2009
RFC 5586
DOI 10.17487/RFC5586
[RFC6374]

Packet Loss and Delay Measurement for MPLS Networks
D. Frost
S. Bryant
September 2011
RFC 6374
DOI 10.17487/RFC6374
[RFC8957]

Synonymous Flow Label Framework
S. Bryant
M. Chen
G. Swallow
S. Sivabalan
G. Mirsky
January 2021
RFC 8957
DOI 10.17487/RFC8957
[RFC5036]

LDP Specification
L. Andersson, Ed.
I. Minei, Ed.
B. Thomas, Ed.
October 2007
RFC 5036
DOI 10.17487/RFC5036
[RFC7026]

Retiring TLVs from the Associated Channel Header of the MPLS Generic Associated Channel
A. Farrel
S. Bryant
September 2013
RFC 7026
DOI 10.17487/RFC7026
[RFC7214]

Moving Generic Associated Channel (G-ACh) IANA Registries to a New Registry
L. Andersson
C. Pignataro
May 2014
RFC 7214
DOI 10.17487/RFC7214

Informative References
[RFC8372]

MPLS Flow Identification Considerations
S. Bryant
C. Pignataro
M. Chen
Z. Li
G. Mirsky
May 2018
RFC 8372
DOI 10.17487/RFC8372
[RFC8321]

Alternate-Marking Method for Passive and Hybrid Performance Monitoring
G. Fioccola, Ed.
A. Capello
M. Cociglio
L. Castaldelli
M. Chen
L. Zheng
G. Mirsky
T. Mizrahi
January 2018
RFC 8321
DOI 10.17487/RFC8321
[RFC3270]

Multi-Protocol Label Switching (MPLS) Support of Differentiated Services
F. Le Faucheur
L. Wu
B. Davie
S. Davari
P. Vaananen
R. Krishnan
P. Cheval
J. Heinanen
May 2002
RFC 3270
DOI 10.17487/RFC3270
[RFC5921]

A Framework for MPLS in Transport Networks
M. Bocci, Ed.
S. Bryant, Ed.
D. Frost, Ed.
L. Levrau
L. Berger
July 2010
RFC 5921
DOI 10.17487/RFC5921
[RFC7190]

Use of Multipath with MPLS and MPLS Transport Profile (MPLS-TP)
C. Villamizar
March 2014
RFC 7190
DOI 10.17487/RFC7190
[RFC7258]

Pervasive Monitoring Is an Attack
S. Farrell
H. Tschofenig
May 2014
BCP 188
RFC 7258
DOI 10.17487/RFC7258
[RFC5920]

Security Framework for MPLS and GMPLS Networks
L. Fang, Ed.
July 2010
RFC 5920
DOI 10.17487/RFC5920